//------------------------------------------------ 
//Program objective:
//- get Total number of time step
//- get Maxproton value(int)
//- get Maxneutron value(int)
//- get Maxabundance value(double)
//- get population 3D array (double)
//- get real time arrray for time step (double)
//- get nonZeroAbundance Array (bool)
//- get nonAbundanceCount (int)
//--------------------------------------------------

package supportingClasses;
import java.io.*;
import java.awt.*;
import java.util.*;

public class ReadFile
  {

  private static String s ; 
  public int count=0;
  public int TotaltimeStep =0;
  public double maxAbundance;
  public double minAbundance;
  public int maxProton;
  public int maxNeutron;
  public int totalTimeStep;
  public int nonZeroAbundanceCount;
  public double [][][] population;
  public double [] time; 
  public static boolean[][] nonZeroAbundance;
   
  public ReadFile (String filename)//throws IOException
    {
    int bufflength=5000000;
    int count=0;
    
    minAbundance = 1.0;
 
    try
      {
      File from_file = new File (filename);
      FileInputStream fis = new FileInputStream (from_file);
	
      //BufferedInputStream b = new BufferedInputStream(fis);
      byte[] buffer = new byte [bufflength];
      int input;
	   
      // Read data into program using loop
      while((input = fis.read(buffer))!=-1)
        { 
        s = new String (buffer);
        }
      fis.close();
      } 
	 
	 
    catch(IOException e)
      {
      System.out.println ("Error .. "+ e.toString());
      }
 
    StringTokenizer st = new StringTokenizer(s.trim());
    
    while (st.hasMoreTokens())
      {
      int step = Integer.parseInt(st.nextToken());
      double realtime =Double.parseDouble(st.nextToken());
      int Z= Integer.parseInt(st.nextToken());
      int N = Integer.parseInt(st.nextToken());
      double abundance =Double.parseDouble(st.nextToken());
		 
      // get maxAbundance 
      if(abundance > 0)
        {
        if(abundance > maxAbundance)
          {
          maxAbundance = abundance;
          }
        if(abundance < minAbundance || minAbundance == -1.0)
          {
          minAbundance = abundance;
          }
        }	 
      // get maxProton
      if(Z > maxProton)
        {
        maxProton = Z;
        }
      //get maxNeutron
      if(N > maxNeutron)
        {
        maxNeutron = N;
        }
      // get total timestep    
      if(step > totalTimeStep)
        {
        totalTimeStep = step;
        } 
      }
    // increase totalTimestep by one since step starts at zero
    totalTimeStep++;

    //initialize length of arrays from max values  
    time = new double[totalTimeStep]; 
    population = new double [maxProton+1][maxNeutron+1][totalTimeStep];
    nonZeroAbundance = new boolean [maxProton+1][maxNeutron+1];

    // define new stringtokeizer to get array data
    StringTokenizer st1 = new StringTokenizer(s.trim());
    while (st1.hasMoreTokens())
      {
      int timestep = Integer.parseInt(st1.nextToken());
      double realtime1 =Double.parseDouble(st1.nextToken());
      int protonNumber = Integer.parseInt(st1.nextToken());
      int neutronNumber =Integer.parseInt(st1.nextToken());
      double abundance1 = Double.parseDouble(st1.nextToken());
      population[protonNumber][neutronNumber][timestep] =abundance1;
      // get array for timestep      
      if(count<= timestep & count< totalTimeStep)
        {   
        time [timestep]= realtime1; 
        count++;
        }	
      }
    getNonZeroAbundance();
    }
  
  private void getNonZeroAbundance()
    {
    nonZeroAbundanceCount = 0;
    
    // Set nonZeroAbundance to false
    for(int i=0; i<=maxProton; i++)
      {
      for(int j=0; j<=maxNeutron; j++)
        {
        nonZeroAbundance[i][j] = false;
        }
      }
        
    // Traverse through the time index, then nProton, then nNeutron. 
    // Once we find an occurence which the abundance is nonzero, create a histogram for that nuclei
    
    for(int i=0; i<totalTimeStep; i++)
      {
      for(int j=0; j<=maxProton; j++)
        {
        for(int k=0; k<=maxNeutron; k++)
          {
          if(population[j][k][i] > 0)
            {
            if(nonZeroAbundance[j][k] == false)
              nonZeroAbundanceCount++;
            nonZeroAbundance[j][k] = true;
            }
          }
        }
      }
    }  
  
  }      
